#version 140
#extension GL_EXT_gpu_shader4 : enable
// playing with kifsMod01.fsh  by milez770

//https://www.shadertoy.com/view/3tyyRD
// Licence CC0
// Adapted, trivialy, for use in VGHD player
/////////////////////////////////////////////
uniform float u_Elapsed;    // The elapsed time in seconds
uniform vec2  u_WindowSize; // Window dimensions in pixels


#define iTime u_Elapsed*0.177  //0.314159  //*0.1666
#define iResolution u_WindowSize


//#define mouse AUTO_MOUSE
//#define MOUSE_SPEED vec2(vec2(0.5,0.577777) * 0.25)
//#define MOUSE_POS   vec2((1.0+cos(iTime*MOUSE_SPEED))*u_WindowSize/2.0)
//#define MOUSE_PRESS vec2(0.0,0.0)
//#define AUTO_MOUSE  vec4( MOUSE_POS, MOUSE_PRESS )
//#define RIGID_SCROLL
// alternatively use static mouse definition
#define iMouse vec4(0.0,0.0, 0.0,0.0)
//#define iMouse vec4(512,256,180,120)
uniform sampler2D iChannel0;
uniform sampler2D iChannel1;
uniform sampler2D iChannel2;
vec4 texture2D_Fract(sampler2D sampler,vec2 P) {return texture2D(sampler,fract(P));}
vec4 texture2D_Fract(sampler2D sampler,vec2 P, float Bias) {return texture2D(sampler,fract(P),Bias);}
#define texture2D texture2D_Fract

vec2 N(float angle){
    return vec2(sin(angle), cos(angle));
}
void main (void)
//void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    // Normalized pixel coordinates (from -.5 to .5)
    vec2 uv = (gl_FragCoord.xy-.5*iResolution.xy)/iResolution.y;
    vec2 mouse = iMouse.xy/iResolution.xy;
    
    // zoom out a little
    uv *= 1.5;
     
    // init col vector
    vec3 col = vec3(0);

    // mirror uv on x axis
    uv = sin(abs(uv));
    
    // rotate angle
    vec2 n = N(mouse.x*3.1415);
    // direction on uv coord
    float d = dot(uv-vec2(.5,0), n);
    //draw a line
    uv -= n*max(0., d)*2.;
    
    // line resolution
    float scale = 1.;
    uv.x += .5;
    n = N(iTime*.1*3.1415);
    for(int i=0; i<10; i++){
    
        uv*=3.;
        scale *= 3.;
        uv.x -= 1.5;
        
        uv.x = abs(uv.x);
        uv.x -= .5;
        // bend
        uv -= n*min(0., dot(uv, n))*2.;
    }
    
    
    
    
    //d = length(uv - vec2(clamp(uv.x, -1., 1.), 0));
    //col+= smoothstep(1./iResolution.y, .0, d/scale);
    uv /= scale;
    // Output to screen
    col += texture2D(iChannel0, uv*2.-iTime*.03).rgb;
    //col.rg += uv;
    gl_FragColor = vec4(col,1.0);
}